## com.saxonica.serialize
Class BinaryEmitter

    java.lang.Object
      net.sf.saxon.serialize.Emitter
          com.saxonica.serialize.BinaryEmitter

All Implemented Interfaces:
  Result, Receiver

Direct Known Subclasses:
  Base64BinaryEmitter, HexBinaryEmitter

    public abstract class BinaryEmitter

extends Emitter

This is an abstract superclass for the two binary output methods saxon:base64Binary and saxon:hexBinary.

Field Summary

Fields inherited from class net.sf.saxon.serialize.Emitter
`allCharactersEncodable, characterSet, namePool, outputProperties, outputStream, pipelineConfig, streamResult, systemId, writer`

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`BinaryEmitter()`

Method Summary
`void` `attribute(int nameCode, int typeCode, CharSequence value, int locationId, int properties)` Notify an attribute.
`void` `characters(CharSequence chars, int locationId, int properties)` Notify character data.
`void` `comment(CharSequence content, int locationId, int properties)` Notify a comment.
`void` `endDocument()` Notify the end of a document node
`void` `endElement()` Notify the end of an element.
`void` `namespace(int namespaceCode, int properties)` Notify a namespace.
`void` `open()` Notify the start of the event stream
`void` `processingInstruction(String name, CharSequence data, int locationId, int properties)` Output a processing instruction
`void` `startContent()` Notify the start of the content, that is, the completion of all attributes and namespaces.
`void` `startDocument(int properties)` Notify the start of a document node
`void` `startElement(int nameCode, int typeCode, int locationId, int properties)` Notify the start of an element
`protected abstract byte[]` `textNodeToBinary(CharSequence chars)`
`boolean` `usesTypeAnnotations()` Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events
`boolean` `usesWriter()` Determine whether the Emitter wants a Writer for character output or an OutputStream for binary output.

Methods inherited from class net.sf.saxon.serialize.Emitter
`close, getConfiguration, getOutputProperties, getOutputStream, getPipelineConfiguration, getSystemId, getWriter, makeOutputStream, makeWriter, setOutputProperties, setOutputStream, setPipelineConfiguration, setStreamResult, setSystemId, setUnparsedEntity, setWriter`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BinaryEmitter

    public BinaryEmitter()

Method Detail

### usesWriter

    public boolean usesWriter()

  Determine whether the Emitter wants a Writer for character output or an OutputStream for binary output. The standard Emitters all use a Writer, so this returns true; but a subclass can override this if it wants to use an OutputStream

  Overrides:
    `usesWriter` in class `Emitter`
  Returns:
    false: this Emitter uses an OutputStream

### open

    public void open()
              throws XPathException

  Description copied from interface: `Receiver`
  Notify the start of the event stream

  Throws:
    `XPathException`

### startDocument

    public void startDocument(int properties)
                       throws XPathException

  Description copied from interface: `Receiver`
  Notify the start of a document node

  Parameters:
    `properties` - bit-significant integer indicating properties of the document node. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException`

### endDocument

    public void endDocument()
                     throws XPathException

  Description copied from interface: `Receiver`
  Notify the end of a document node

  Throws:
    `XPathException`

### startElement

    public void startElement(int nameCode,
                             int typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  Description copied from interface: `Receiver`
  Notify the start of an element

  Parameters:
    `nameCode` - integer code identifying the name of the element within the name pool.
    `typeCode` - integer code identifying the element's type within the name pool. The value -1 indicates the default type, xs:untyped.
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - bit-significant properties of the element node. If there are no revelant properties, zero is supplied. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException`

### namespace

    public void namespace(int namespaceCode,
                          int properties)
                   throws XPathException

  Description copied from interface: `Receiver`
  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element. The events represent namespace declarations and undeclarations rather than in-scope namespace nodes: an undeclaration is represented by a namespace code of zero. If the sequence of namespace events contains two A namespace must not conflict with any namespaces already used for element or attribute names.

  Parameters:
    `namespaceCode` - an integer: the top half is a prefix code, the bottom half a URI code. These may be translated into an actual prefix and URI using the name pool. A prefix code of zero represents the empty prefix (that is, the default namespace). A URI code of zero represents a URI of "", that is, a namespace undeclaration.
    `properties` - The most important property is REJECT_DUPLICATES. If this property is set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error: it sets the REJECT_DUPLICATES flag, and this is treated as a hard error.
  Throws:
    `XPathException`

### attribute

    public void attribute(int nameCode,
                          int typeCode,
                          CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Description copied from interface: `Receiver`
  Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.

  Parameters:
    `nameCode` - The name of the attribute, as held in the name pool
    `typeCode` - The type of the attribute, as held in the name pool. The additional bit NodeInfo.IS_DTD_TYPE may be set to indicate a DTD-derived type.
    `value` - the string value of the attribute
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this attribute
  NO_SPECIAL_CHARACTERS
    Attribute value contains no special characters
  Throws:
    `XPathException`

### startContent

    public void startContent()
                      throws XPathException

  Description copied from interface: `Receiver`
  Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial receiver of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.

  Throws:
    `XPathException`

### endElement

    public void endElement()
                    throws XPathException

  Description copied from interface: `Receiver`
  Notify the end of an element. The receiver must maintain a stack if it needs to know which element is ending.

  Throws:
    `XPathException`

### characters

    public void characters(CharSequence chars,
                           int locationId,
                           int properties)
                    throws XPathException

  Description copied from interface: `Receiver`
  Notify character data. Note that some receivers may require the character data to be sent in a single event, but in general this is not a requirement.

  Parameters:
    `chars` - The characters
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this text node
  USE_CDATA
    Output as a CDATA section
  Throws:
    `XPathException`

### textNodeToBinary

    protected abstract byte[] textNodeToBinary(CharSequence chars)
                                        throws XPathException

  Throws:
    `XPathException`

### processingInstruction

    public void processingInstruction(String name,
                                      CharSequence data,
                                      int locationId,
                                      int properties)
                               throws XPathException

  Description copied from interface: `Receiver`
  Output a processing instruction

  Parameters:
    `name` - The PI name. This must be a legal name (it will not be checked).
    `data` - The data portion of the processing instruction
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the PI.
  Throws:
    `XPathException`

### comment

    public void comment(CharSequence content,
                        int locationId,
                        int properties)
                 throws XPathException

  Description copied from interface: `Receiver`
  Notify a comment. Comments are only notified if they are outside the DTD.

  Parameters:
    `content` - The content of the comment
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the comment.
  Throws:
    `XPathException`

### usesTypeAnnotations

    public boolean usesTypeAnnotations()

  Description copied from interface: `Receiver`
  Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events

  Returns:
    true if the Receiver makes any use of this information. If false, the caller may supply untyped nodes instead of supplying the type annotation

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.